Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSystemOnceExecute.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSystemOnceExecute.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSystemOnceExecute.cs	(revision 51)
@@ -76,31 +76,38 @@
             bool ProcessFlg = true;
             try
             {
+                // 初期化に失敗したら処理しない
+                if (!m_bExecuteFlg) return;
+
                 // 本日の初回起動がされている場合は処理しない
                 if (!ExecuteCheck(ref m_lastsessionDate)) return;
+                
                 // 更新済みにするために日付の更新
-                UpDateTargetDate(DateTime.Now);
+                if (!(ProcessFlg = UpDateTargetDate(DateTime.Now))) return;
 
-                // 初期化に失敗したら処理しない
-                if (!m_bExecuteFlg) return;
-
-                // データチェック
+                // ----- データチェック
                 // 日付の期限チェックを行う
-                ProcessFlg = SubmittedDateCheck(m_lastsessionDate);
+                if(!(ProcessFlg = SubmittedDateCheck(m_lastsessionDate))) return;
 
                 // 見積有効期限切れを非受注へ移行する
-                if (ProcessFlg) ProcessFlg &= ChangeNonOrdersData();
+                if (!(ProcessFlg = ChangeNonOrdersData())) return;
 
+                // 開始期日がきた給与を適用する
+                if (!(ProcessFlg = SetNewPayrollCheck())) return;
+
                 // 工事詳細台帳の給与を加算する
-                if (ProcessFlg) ProcessFlg &= CalculateDaysSalary();
+                if (!(ProcessFlg = CalculateDaysSalary(m_lastsessionDate))) return;
 
-                // エラー時は元の日付に更新
-                if (!ProcessFlg) UpDateTargetDate(m_lastsessionDate);
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                // エラー時は元の日付に更新
+                if (!ProcessFlg) UpDateTargetDate(m_lastsessionDate);
+            }
         }
         #endregion
 
@@ -248,10 +255,13 @@
         private bool SubmittedDateCheck(DateTime StartDate)
         {
             IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
+            IOConstructionBaseInfoDetail cbiDDB = new IOConstructionBaseInfoDetail();
+            IOMessageBoardData mbdDB = new IOMessageBoardData();
+            IOMessageBoardTerget mbtDB = new IOMessageBoardTerget();
             try
             {
                 // 工事基本情報を期限テーブルに設定している状態分取得する
-                string strSQL = " WHERE CONSTRUCTIONSTATUSFLG IN (SELECT DISTINCT CONSTRUCTIONSTATUSFLG FROM TERMMASTER)";
+                string strSQL = " WHERE CONSTRUCTIONSTATUSFLG IN (SELECT DISTINCT A1.CONSTRUCTIONSTATUSFLG FROM TERMMASTER A1)";
                 strSQL = " ORDER BY CONSTRUCTIONSTATUSFLG ASC, CONSTRUCTIONCODE ASC";
                 List<ConstructionBaseInfo> cbiList = new List<ConstructionBaseInfo>();
                 if (!cbiDB.SelectAction(strSQL, ref cbiList)) return true;
@@ -266,6 +276,11 @@
                     StartDate = DateTime.Now.AddDays(-1);
                 }
 
+                cbiDB.connect(); cbiDB.beginTran();
+                cbiDDB.connect(); cbiDDB.beginTran();
+                mbdDB.connect(); mbdDB.beginTran();
+                mbtDB.connect(); mbtDB.beginTran();
+
                 bool procflg = true;
                 // 経過日数分処理を行う
                 for (int ix = 0; ix < diffDays; ix++)
@@ -273,20 +288,44 @@
                     DateTime CriteriaDate = StartDate.AddDays((ix + 1));
                     foreach (ConstructionBaseInfo wrkRec in cbiList)
                     {
-                        string sErrorMessage = string.Empty;
-                        string sBackColor = string.Empty;
-                        string sForeColor = string.Empty;
+                        List<TermMaster> term = new List<TermMaster>();
                         // 増減工事の子は処理しない
                         if (wrkRec.TyingFlg == (int)CommonDefine.BaseInfoTyingFlg.Tying) continue;
+                        // 結合工事の親は処理しない
+                        if (wrkRec.JoinFlg == (int)CommonDefine.BaseInfoJoinFlg.JoinParent) continue;
                         // チェック
-                        if (!ConstructionStatusCheck(wrkRec, CriteriaDate, ref sErrorMessage, ref sBackColor, ref sForeColor))
+                        if (!ConstructionStatusCheck(wrkRec, CriteriaDate, ref term))
                         {
-                            procflg = false;
-                            break;
+                            // 掲示板にメッセージを載せるためにループ処理
+                            foreach (TermMaster CurTerm in term)
+                            {
+                                // メッセージ作成
+                                if (!MakeMassageData(mbdDB, mbtDB, cbiDDB, wrkRec, CurTerm, CriteriaDate))
+                                {
+                                    procflg = false;
+                                    break;
+                               }
+                            }
                         }
                     }
                     if (!procflg) break;
                 }
+
+                if (procflg)
+                {
+                    cbiDB.commit();
+                    cbiDDB.commit();
+                    mbdDB.commit();
+                    mbtDB.commit();
+                }
+                else
+                {
+                    cbiDB.rollback();
+                    cbiDDB.rollback();
+                    mbdDB.rollback();
+                    mbtDB.rollback();
+                }
+
                 return procflg;
             }
             catch (Exception ex)
@@ -297,6 +336,9 @@
             finally
             {
                 cbiDB.close(); cbiDB = null;
+                cbiDDB.close(); cbiDDB = null;
+                mbdDB.close(); mbdDB = null;
+                mbtDB.close(); mbtDB = null;
             }
         }
         #endregion
@@ -305,27 +347,14 @@
         /// <summary>
         /// チェック処理
         /// </summary>
-        /// <param name="checkRec">対象工事情報</param>
-        /// <param name="NowDate">基準日付</param>
-        /// <param name="sErrorMessage">エラーメッセージ</param>
-        /// <param name="sBackColor">背景色</param>
-        /// <param name="sForeColor">文字色</param>
-        /// <param name="bCreateMessage">秘書からの連絡にメッセージ作成</param>
         /// <returns></returns>
-        public bool ConstructionStatusCheck(ConstructionBaseInfo checkRec,
-                                            DateTime CriteriaDate,
-                                            ref string sErrorMessage,
-                                            ref string sBackColor,
-                                            ref string sForeColor,
-                                            bool bCreateMessage = true)
+        public bool ConstructionStatusCheck(ConstructionBaseInfo checkRec, DateTime CriteriaDate, ref List<TermMaster> TermRec)
         {
             try
             {
                 // 初期化に失敗していたら処理しない
-                if (!m_bExecuteFlg) return false;
+                if (!m_bExecuteFlg) return true;
 
-                TermMaster TermRec = new TermMaster();
-
                 // 取得データの進捗状態がチェック判定テーブルにあるかの存在チェック
                 bool exestFlg = false;
                 int itblCnt = 0;
@@ -449,22 +478,10 @@
                     // チェック項目に該当すればメッセージ・色をセットする
                     if (ErrFlg)
                     {
-                        TermRec = wrkCheck;
-                        sErrorMessage = wrkCheck.SendTitle + "／" + wrkCheck.SendMessage;
-                        sBackColor = wrkCheck.BackColor;
-                        sForeColor = wrkCheck.ForeColor;
-
-
-                        // 掲示板にメッセージを載せない場合があるのでフラグ制御
-                        if (bCreateMessage)
-                        {
-                            // メッセージ作成
-                            MakeMassageData(checkRec, TermRec, CriteriaDate);
-                        }
+                        TermRec.Add(wrkCheck);
+                        bCheckNoError = false;
                     }
                 }
-
-
                 return bCheckNoError;
             }
             catch (Exception ex)
@@ -479,38 +496,39 @@
         /// <summary>
         /// メッセージ作成
         /// </summary>
-        /// <param name="wrkRec"></param>
-        /// <param name="bCreateMessage"></param>
-        /// <param name="DateTime CriteriaDate"></param>
-        /// <returns></returns>
-        private void MakeMassageData(ConstructionBaseInfo wrkRec, TermMaster CheckRec, DateTime CriteriaDate)
+        private bool MakeMassageData(IOMessageBoardData mbdDB,
+                                        IOMessageBoardTerget mbtDB,
+                                        IOConstructionBaseInfoDetail cbiDB,
+                                        ConstructionBaseInfo wrkRec, TermMaster CheckRec, DateTime CriteriaDate)
         {
-            IOConstructionBaseInfoDetail cbiDB = new IOConstructionBaseInfoDetail();
-            IOMPersonInCharge picDB = new IOMPersonInCharge();
             try
             {
-                // 工事名称取得
-                string strSQL = string.Format(" Where (ConstructionCode = {0} And DETAILNO = {1})"
-                                                , wrkRec.ConstructionCode, ((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName).ToString());
-                List<ConstructionBaseInfoDetail> NameList = new List<ConstructionBaseInfoDetail>();
-                ConstructionBaseInfoDetail TmpName = new ConstructionBaseInfoDetail();
-                if (cbiDB.SelectAction(strSQL, ref NameList))
-                    if (NameList.Count != 0) TmpName.DetailString = NameList[0].DetailString;
+                // 工事名称・営業担当者・工事担当者取得
+                string strSQL = "SELECT A.DETAILSTRING, B.PERSONCODE SCODE, B.PERSONNAME SNAME, C.PERSONCODE CCODE, C.PERSONNAME CNAME";
+                strSQL += " FROM CONSTRUCTIONBASEINFO P";
+                strSQL += " LEFT JOIN PERSONINCHARGEMASTER B ON B.PERSONCODE = P.SALESPERSONCODE";
+                strSQL += " LEFT JOIN PERSONINCHARGEMASTER C ON C.PERSONCODE = P.CONSTRUCTIONPERSONCODE";
+                strSQL += " , CONSTRUCTIONBASEINFODETAIL A";
+                strSQL += string.Format(" WHERE P.CONSTRUCTIONCODE = {0}",wrkRec.ConstructionCode);
+                strSQL += string.Format(" AND A.CONSTRUCTIONCODE = P.CONSTRUCTIONCODE AND A.DETAILNO = {0}", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                ArrayList arList = new ArrayList();
+                if (!cbiDB.ExecuteReader(strSQL, ref arList)) return false;
+                
+                string DetailString = string.Empty;
+                int SalesPersonCode = 0;
+                string SalesPersonName = string.Empty;
+                int ConstructionPersonCode = 0;
+                string ConstructionPersonName = string.Empty;
+                foreach (object[] onjwrk in arList)
+                {
+                    DetailString = CommonMotions.cnvString(onjwrk[0]);
+                    SalesPersonCode = CommonMotions.cnvInt(onjwrk[1]);
+                    SalesPersonName = CommonMotions.cnvString(onjwrk[2]);
+                    ConstructionPersonCode = CommonMotions.cnvInt(onjwrk[3]);
+                    ConstructionPersonName = CommonMotions.cnvString(onjwrk[4]);
+                    break;
+                }
 
-                // 営業担当者取得
-                strSQL = string.Format(" Where PersonCode = {0}", wrkRec.SalesPersonCode);
-                List<PersonInChargeMaster> SalesList = new List<PersonInChargeMaster>();
-                PersonInChargeMaster TmpSales = new PersonInChargeMaster();
-                if (picDB.SelectAction(strSQL, ref SalesList))
-                    if (SalesList.Count != 0) TmpSales = SalesList[0];
-
-                // 工事担当者取得
-                strSQL = string.Format(" Where PersonCode = {0}", wrkRec.ConstructionPersonCode);
-                List<PersonInChargeMaster> ConstructionList = new List<PersonInChargeMaster>();
-                PersonInChargeMaster TmpConstruction = new PersonInChargeMaster();
-                if (picDB.SelectAction(strSQL, ref ConstructionList))
-                    if (ConstructionList.Count != 0) TmpConstruction = ConstructionList[0];
-
                 // 新規メッセージ作成
                 MessageBoardData WriteData = new MessageBoardData();
                 List<MessageBoardTerget> WriteDetail = new List<MessageBoardTerget>();
@@ -525,7 +543,7 @@
                 WriteData.LinkType = (int)CommonDefine.LinkType.ConstructionInfo;
                 WriteData.LinkMessage = string.Format("工事番号：{0} 工事名称：{1}"
                                                                             , CommonMotions.cnvStringCodeFromInt(wrkRec.ConstructionCode, "-", 8)
-                                                                            , TmpName.DetailString);
+                                                                            , DetailString);
                 WriteData.LinkCode = string.Format("{0}", CommonMotions.cnvStringCodeFromInt(wrkRec.ConstructionCode, "-", 8));
 
                 // 伝言内容
@@ -542,12 +560,12 @@
 
                 // 掲示板対象者テーブル
                 MessageBoardTerget DetailTbl = new MessageBoardTerget();
-                DetailTbl.ToCode = TmpSales.PersonCode;                                                     // 対象者コード
-                DetailTbl.ToName = TmpSales.PersonName;	                                                    // 対象者
-                if (TmpConstruction.PersonCode != 0)
+                DetailTbl.ToCode = SalesPersonCode;                                                     // 対象者コード
+                DetailTbl.ToName = SalesPersonName;	                                                    // 対象者
+                if (ConstructionPersonCode != 0)
                 {
-                    DetailTbl.ToCode = TmpConstruction.PersonCode;                                          // 対象者コード
-                    DetailTbl.ToName = TmpConstruction.PersonName;	                                        // 対象者
+                    DetailTbl.ToCode = ConstructionPersonCode;                                          // 対象者コード
+                    DetailTbl.ToName = ConstructionPersonName;	                                        // 対象者
                 }
                 WriteDetail.Add(DetailTbl);
 
@@ -555,18 +573,15 @@
                 WriteData.MessageFlag = (int)CommonDefine.MessageFlg.Secretary;
 
                 // 掲示板へメッセージを載せる
-                ClsMessageBoradAccess.CreateMessage(WriteData, WriteDetail);
+                if (!ClsMessageBoradAccess.CreateMessage(mbdDB, mbtDB, WriteData, WriteDetail)) return false;
 
+                return true;
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return false;
             }
-            finally
-            {
-                picDB.close(); picDB = null;
-                cbiDB.close(); cbiDB = null;
-            }
         }
         #endregion
 
@@ -584,9 +599,9 @@
                 int iCode3 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("見積提出")).Key;
 
                 // 対象データが存在するかを確認する
-                string strSQL = "SELECT COUNT(*) FROM CONSTRUCTIONBASEINFO WHERE DATE(ESTIMATESSUBMITTEDDATE) != DATE_FORMAT('0001/01/01','%Y/%m/%d')";
-                strSQL += string.Format(" AND DATE(ESTIMATESSUBMITTEDDATE + {0})", s_NonOrderDay);
-                strSQL += string.Format(" < DATE_FORMAT('{0}','%Y/%m/%d')", DateTime.Now.ToShortDateString());
+                string strSQL = "SELECT COUNT(*) FROM CONSTRUCTIONBASEINFO WHERE DATE(ESTIMATESSUBMITTEDDATE) != STR_TO_DATE('0001/01/01','%Y/%m/%d')";
+                strSQL += string.Format(" AND DATE(DATE_ADD(ESTIMATESSUBMITTEDDATE, INTERVAL {0} DAY))", s_NonOrderDay);
+                strSQL += string.Format(" < STR_TO_DATE('{0}','%Y/%m/%d')", DateTime.Now.ToShortDateString());
                 strSQL += string.Format(" AND CONSTRUCTIONSTATUSFLG IN({0}, {1})", iCode2, iCode3);
                 strSQL += string.Format(" AND ESTIMATETYPE IN ({0}, {1})", (int)CommonDefine.BaseInfoEstimateType.Normal, (int)CommonDefine.BaseInfoEstimateType.GetBudget);
                 ArrayList arList = new ArrayList();
@@ -599,15 +614,16 @@
                 if (Common.CommonMotions.cnvInt(wrkcount[0]) == 0) return true;
 
                 // 対象データが存在すれば更新する
-                strSQL = string.Format("UPDATE CONSTRUCTIONBASEINFO SET CONSTRUCTIONSTATUSFLG = {0}", iCode1);
+                strSQL = string.Format("UPDATE CONSTRUCTIONBASEINFO SET CONSTRUCTIONSTATUSFLG = {0},", iCode1);
+                strSQL += string.Format(" NONORDERDATE = STR_TO_DATE('{0}','%Y/%m/%d')", DateTime.Today.ToShortDateString());
                 strSQL += " WHERE CONSTRUCTIONCODE IN";
-                strSQL += " (SELECT CONSTRUCTIONCODE FROM"; // MySql対応（Updateの副問合せ対応）
-                strSQL += " (SELECT CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO WHERE DATE(ESTIMATESSUBMITTEDDATE) != DATE_FORMAT('0001/01/01','%Y/%m/%d')";
-                strSQL += string.Format(" AND DATE(ESTIMATESSUBMITTEDDATE + {0})", s_NonOrderDay);
-                strSQL += string.Format(" < DATE_FORMAT('{0}','%Y/%m/%d')", DateTime.Now.ToShortDateString());
+                strSQL += " (SELECT CONSTRUCTIONCODE from ("; // MySql対応（Updateの副問合せ対応）
+                strSQL += " (SELECT CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO WHERE DATE(ESTIMATESSUBMITTEDDATE) != STR_TO_DATE('0001/01/01','%Y/%m/%d')";
+                strSQL += string.Format(" AND DATE(DATE_ADD(ESTIMATESSUBMITTEDDATE, INTERVAL {0} DAY))", s_NonOrderDay);
+                strSQL += string.Format(" < STR_TO_DATE('{0}','%Y/%m/%d')", DateTime.Now.ToShortDateString());
                 strSQL += string.Format(" AND CONSTRUCTIONSTATUSFLG IN({0}, {1})", iCode2, iCode3);
                 strSQL += string.Format(" AND ESTIMATETYPE IN ({0}, {1}))", (int)CommonDefine.BaseInfoEstimateType.Normal, (int)CommonDefine.BaseInfoEstimateType.GetBudget);
-                strSQL += " AS TMP)"; // MySql対応（Updateの副問合せ対応）
+                strSQL += " ) AS TMP"; // MySql対応（Updateの副問合せ対応）
                 if (!BaseDB.ExecuteNonQuery(strSQL))
                 {
                     logger.ErrorFormat("工事基本情報更新エラー　非受注案件移行処理失敗：{0}：{1}", CommonMotions.GetMethodName(), strSQL);
@@ -632,13 +648,21 @@
         /// <summary>
         /// 工事詳細台帳の給与を加算する
         /// </summary>
-        private bool CalculateDaysSalary()
+        private bool CalculateDaysSalary(DateTime lastDate)
         {
             IOConstructionLedger LedgerDB = new IOConstructionLedger();
             try
             {
+                int iCode1 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key;
+                int iCode2 = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("施工完了")).Key;
+
                 // 入力完了以外を対象にする
-                string strSQL = " WHERE ComplateFlg <> 1 ORDER BY ConstructionStart ASC";
+                string strSQL = string.Format(" A WHERE A.ComplateFlg <> {0}", (int)CommonDefine.ComplateTitleNo.Complated);
+                strSQL += " AND A.CONSTRUCTIONCODE IN (SELECT A1.CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO A1";
+                strSQL += string.Format(" WHERE A1.CONSTRUCTIONSTATUSFLG != {0}", iCode1);
+                strSQL += string.Format(" AND A1.CONSTRUCTIONSTATUSFLG < {0})", iCode2);
+                strSQL += " AND DATE(A.CONSTRUCTIONSTART) <= DATE(NOW())";
+                strSQL += " ORDER BY A.CONSTRUCTIONSTART ASC";
                 List<ConstructionLedger> LedgerList = new List<ConstructionLedger>();
                 // エラーもしくはデータが無い場合は処理しない
                 if (!LedgerDB.SelectAction(strSQL, ref LedgerList) || LedgerList.Count == 0) return true;
@@ -645,11 +669,8 @@
 
                 foreach (ConstructionLedger CurRec in LedgerList)
                 {
-                    // 当日が範囲外ならば処理しない
-                    if (DateTime.Now < CurRec.ConstructionStart.Date || CurRec.ConstructionEnd.Date < DateTime.Now) continue;
-                    
                     // 給与を加算する
-                    if (!ClsChangeLedgerData.CalculatePayment(CurRec.ConstructionCode, DateTime.Now, false)) break;
+                    ClsChangeLedgerData.CalculatePayment(CurRec, DateTime.Now, lastDate);
                 }
 
                 return true;
@@ -665,5 +686,65 @@
             }
         }
         #endregion
+
+        #region 開始期日がきた給与を適用する
+        /// <summary>
+        /// 開始期日がきた給与を適用する
+        /// </summary>
+        /// <returns></returns>
+        private bool SetNewPayrollCheck()
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // 適用する給与と金額が違うデータを検索する
+                string strSQL = "SELECT A.PERSONCODE, A.MONTHLYSALARY, A.YEARSALARY, A.STARTDATE, C.MONTHLYSALARY, C.YEARSALARY";
+                strSQL += " FROM PERSONSALARYMASTER A,";
+                strSQL += " (SELECT PERSONCODE, MAX(STARTDATE) sDate FROM PERSONSALARYMASTER";
+                strSQL += string.Format(" WHERE DATE(STARTDATE) <= STR_TO_DATE('{0}') GROUP BY PERSONCODE) B,", DateTime.Today.ToShortDateString());
+                strSQL += " PERSONINCHARGEMASTER C";
+                strSQL += "  WHERE A.PERSONCODE = B.PERSONCODE AND A.STARTDATE = B.sDate";
+                strSQL += " AND C.PERSONCODE = A.PERSONCODE";
+                strSQL += " AND (A.MONTHLYSALARY != C.MONTHLYSALARY OR A.YEARSALARY <> C.YEARSALARY)";
+                ArrayList arList = new ArrayList();
+                if (!PersonDB.ExecuteReader(strSQL, ref arList)) return false;
+
+                // 更新処理
+                PersonDB.connect(); PersonDB.beginTran();
+                foreach(object[] objRec in arList)
+                {
+                    // 月給与更新
+                    if (!PersonDB.UpdateFeild(CommonMotions.cnvInt(objRec[0]),
+                                            (int)IOMPersonInCharge.ColumnCnt.MonthlySalary,
+                                            CommonMotions.cnvDouble(objRec[1]), false))
+                    {
+                        PersonDB.rollback();
+                        return false;
+                    }
+                    // 年給与更新
+                    if (!PersonDB.UpdateFeild(CommonMotions.cnvInt(objRec[0]),
+                                            (int)IOMPersonInCharge.ColumnCnt.YearSalary,
+                                            CommonMotions.cnvDouble(objRec[2]), false))
+                    {
+                        PersonDB.rollback();
+                        return false;
+                    }
+                }
+
+                PersonDB.commit();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+            }
+        }
+        #endregion
     }
 }
Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsUpDate.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsUpDate.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsUpDate.cs	(revision 51)
@@ -6,6 +6,7 @@
 using System.Security.Cryptography;
 using System.Text;
 using System.Threading.Tasks;
+using System.IO.Compression;
 
 namespace ProcessManagement.Common
 {
@@ -14,100 +15,80 @@
     /// </summary>
     public static class ClsUpDate
     {
+// ▼自動更新VPS対応▼
+        // サーバからファイルダウンロード
+        private static void download(String serverPath, String downloadSakiPath)
+        {
+            //WebClientオブジェクトを作成
+            System.Net.WebClient wc = new System.Net.WebClient();
+            //ログインユーザー名とパスワードを指定
+            wc.Credentials =
+                new System.Net.NetworkCredential(
+                    CommonDefine.s_FTP_USER_NAME, CommonDefine.s_FTP_PASSWORD);
+            //FTPサーバーからダウンロードする
+            wc.DownloadFile(serverPath, downloadSakiPath);
+            //解放する
+            wc.Dispose();
+        }
+// ▲自動更新VPS対応▲
         #region 使用定義
         //log4netログを使用する
         private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
         #endregion
 
-        #region ファイルのハッシュ値と更新日付を確認する
+        #region ファイルをコピーする
         /// <summary>
         /// ファイルのハッシュ値と更新日付を確認する
         /// </summary>
         /// <returns></returns>
-        public static bool ProgramTimeStampCheck()
+        public static bool UpdateAndEnvFileCopy()
         {
-            try
-            {
-                bool bRet = true;                       // 戻り値  
-                bool bCopyUpdataProc = false;           // アップデートPGコピーフラグ
-                string srcUpdataProc = string.Empty;    // コピー元ファイルパス作成エリア
-                string destUpdataProc = string.Empty;   // コピー先ファイルパス作成エリア
+            bool bRet = true;                       // 戻り値  
 
-                // デバック以外は使わない
-                //return true;
-                // 接続できなければ処理しない
-                if (!Directory.Exists(CommonDefine.s_UPDATE_FILE_PATH)) return true;
+            // Windows TEMPフォルダパス 
+            string tempPath = Path.GetTempPath();
+            // アップデートファイルパス
+            string updateFilePath = tempPath + CommonDefine.s_UPDATE_MODULE;
+            // サーバ更新モジュールzipファイル（ダウンロード後）
+            string updateModuleZip = tempPath + CommonDefine.s_UPDATE_MODULE + ".zip";
 
-                // コピー元(サーバー)ファイルリストを取得する
-                string[] files = Directory.GetFiles(CommonDefine.s_UPDATE_FILE_PATH);
-                foreach (string sourceFile in files)
-                {
-                    // ファイル名を取得する
-                    int spoint = sourceFile.LastIndexOf("\\") + 1;
-                    string Procename = sourceFile.Substring(spoint);
-                    // コピー先(カレント)ファイル名作成
-                    string destinationFile = System.Environment.CurrentDirectory + "\\" + Procename;
-                    // コピー先(カレント)にファイルがない
-                    if (!File.Exists(@destinationFile))
-                    {
-                        // コピープロセスが無い場合はここでコピー
-                        if (CommonDefine.s_UPDATECOPY_NAME == Procename)
-                        {
-                            srcUpdataProc = @sourceFile;
-                            destUpdataProc = @destinationFile;
-                            bCopyUpdataProc = true;
-                        }
-                        else
-                        {
-                            bRet = false;
-                        }
-                        continue;
-                    }
+            // 更新モジュール置き換え
+            // 更新モジュールzipあるか存在チェック
+            if (System.IO.Directory.Exists(tempPath + CommonDefine.s_UPDATE_MODULE))
+            {
+                // zip削除
+                System.IO.File.Delete(updateModuleZip);
+                // ダウンロードファイル削除
+                System.IO.Directory.Delete(tempPath + CommonDefine.s_UPDATE_MODULE, true);
+            }
+            // 更新モジュールZipダウンロード
+            download(
+                CommonDefine.s_FTP_SERVER_PATH + CommonDefine.s_UPDATE_MODULE + ".zip", updateModuleZip);
+            // 更新モジュール解凍
+            ZipFile.ExtractToDirectory(updateModuleZip, tempPath);
 
-                    // ハッシュ値を取得する
-                    // ----- コピー元ファイル
-                    string srcHash = CommonMotions.GetFileHashData(@sourceFile);
-                    // ----- コピー先ファイル
-                    string destHash = CommonMotions.GetFileHashData(@destinationFile);
-
-                    // ファイルが違う
-                    if (srcHash != destHash)
-                    {
-                        // 更新時間を確認する
-                        // ----- コピー元ファイル
-                        DateTime srcTimeStamp = CommonMotions.GetFileTimeStamp(@sourceFile, 'U');
-                        // ----- コピー先ファイル
-                        DateTime destTimeStamp = CommonMotions.GetFileTimeStamp(@destinationFile, 'U');
-                        // コピー元ファイルが新しくない
-                        if (srcTimeStamp <= destTimeStamp) continue;
-                        
-                        // コピープロセスが新しい場合はここでコピー
-                        if (CommonDefine.s_UPDATECOPY_NAME == Procename)
-                        {
-                            srcUpdataProc = @sourceFile;
-                            destUpdataProc = @destinationFile;
-                            bCopyUpdataProc = true;
-                        }
-                        else
-                        {
-                            bRet = false;
-                        }
-                    }
-                }
-
-                // コピープロセスのコピー
-                if (bCopyUpdataProc)
+            // コピー元(サーバー)ファイルリストを取得する
+            string[] files = Directory.GetFiles(updateFilePath);
+            foreach (string sourceFile in files)
+            {
+                // ファイル名を取得する
+                int spoint = sourceFile.LastIndexOf("\\") + 1;
+                string Procename = sourceFile.Substring(spoint);
+                // コピー先(カレント)ファイル名作成
+                string destinationFile = System.Environment.CurrentDirectory + "\\" + Procename;
+                // updatecopy.exeだったらコピー
+                if (CommonDefine.s_UPDATECOPY_NAME == Procename)
                 {
-                    File.Copy(@srcUpdataProc, @destUpdataProc, true);
+                    // コピー
+                    File.Copy(@sourceFile, @destinationFile, true);
                 }
+            }
+            // zip削除
+            System.IO.File.Delete(tempPath + CommonDefine.s_UPDATE_MODULE + ".zip");
+            // ダウンロードファイル削除
+            System.IO.Directory.Delete(tempPath + CommonDefine.s_UPDATE_MODULE, true);
 
-                return bRet;
-            }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return false;
-            }
+            return bRet;
         }
         #endregion
     }
